using System;

namespace Palindrom_shuffle
{
    class Program
    {
        static void Main(string[] args)
        {         
            char[] T = Console.ReadLine().ToCharArray();
            int n = T.Length;

            int prvo_j = -1;
            int poslednje = -1;
            
            for (int i = 0; i < n/2; i++)
            {
                if (T[i] != T[n - 1 - i])
                {
                    if (prvo_j == -1)
                    {
                        prvo_j = n - 1 - i;
                        poslednje = prvo_j;
                    }
                    for(int j = n-1-i;j>=i;j--)
                    {
                        if(j == i)
                        {
                            char tmp = T[i];
                            T[i] = T[(n+1)/2];
                            T[(n + 1) / 2] = tmp;
                            poslednje = i;
                            i--;
                            break;
                        }
                        if (T[j] == T[i])
                        {
                            char tmp = T[j];
                            T[j] = T[n-1-i];
                            T[n - 1 - i] = tmp;
                            if(j < poslednje)
                            {
                                poslednje = j;
                            }
                            break;
                        }  
                    }
                }
            }
            Console.WriteLine(prvo_j - poslednje + 1);           
        }
    }
}